diff -bruN freeswan-1.9.orig/pluto/connections.c freeswan-1.9/pluto/connections.c
--- freeswan-1.9.orig/pluto/connections.c	Sun Jan 28 16:03:02 2001
+++ freeswan-1.9/pluto/connections.c	Wed Jun  6 16:37:02 2001
@@ -1052,47 +1296,47 @@
  * not process a packet output by an eroute.
  */
 #ifdef NEVER
-bool
-check_nexthop(const struct connection *c)
-{
-    struct connection *d;
-
-    if (addrinsubnet(&c->this.host_nexthop, &c->that.client))
-    {
-	loglog(RC_LOG_SERIOUS, "cannot perform routing for connection \"%s\""
-	    " because nexthop is within peer's client network",
-	    c->name);
-	return FALSE;
-    }
-
-    for (d = connections; d != NULL; d = d->next)
-    {
-	if (d->routed)
-	{
-	    if (addrinsubnet(&c->this.host_nexthop, &d->that.client))
-	    {
-		loglog(RC_LOG_SERIOUS, "cannot do routing for connection \"%s\"
-		    " because nexthop is contained in"
-		    " existing routing for connection \"%s\"",
-		    c->name, d->name);
-		return FALSE;
-	    }
-	    if (addrinsubnet(&d->this.host_nexthop, &c->that.client))
-	    {
-		loglog(RC_LOG_SERIOUS, "cannot do routing for connection \"%s\"
-		    " because it contains nexthop of"
-		    " existing routing for connection \"%s\"",
-		    c->name, d->name);
-		return FALSE;
-	    }
-	}
-    }
-    return TRUE;
-}
+//bool
+//check_nexthop(const struct connection *c)
+//{
+//    struct connection *d;
+//
+//    if (addrinsubnet(&c->this.host_nexthop, &c->that.client))
+//    {
+//	loglog(RC_LOG_SERIOUS, "cannot perform routing for connection \"%s\""
+//	    " because nexthop is within peer's client network",
+//	    c->name);
+//	return FALSE;
+//    }
+//
+//    for (d = connections; d != NULL; d = d->next)
+//    {
+//	if (d->routed)
+//	{
+//	    if (addrinsubnet(&c->this.host_nexthop, &d->that.client))
+//	    {
+//		loglog(RC_LOG_SERIOUS, "cannot do routing for connection \"%s\"
+//		    " because nexthop is contained in"
+//		    " existing routing for connection \"%s\"",
+//		    c->name, d->name);
+//		return FALSE;
+//	    }
+//	    if (addrinsubnet(&d->this.host_nexthop, &c->that.client))
+//	    {
+//		loglog(RC_LOG_SERIOUS, "cannot do routing for connection \"%s\"
+//		    " because it contains nexthop of"
+//		    " existing routing for connection \"%s\"",
+//		    c->name, d->name);
+//		return FALSE;
+//	    }
+//	}
+//    }
+//    return TRUE;
+//}
 #endif /* NEVER */
 
 /* an ISAKMP SA has been established.
- * Note the serial number, and unorient any connections with
+ * Note the serial number, and release any connections with
  * the same peer ID but different peer IP address.
  */
 bool uniqueIDs = FALSE;	/* --uniqueids? */
@@ -1111,74 +1355,179 @@
 
 	for (d = connections; d != NULL; )
 	{
-	    struct connection *next = d->next;	/* might move underneath us */
+	    struct connection *next = d->ac_next;	/* might move underneath us */
 
-	    if (same_id(&c->that.id, &d->that.id)
-	    && !sameaddr(&c->that.host_addr, &d->that.host_addr)
-	    && !HasWildcardIP(*d))
+           if (d->kind != CK_TEMPLATE
+           && same_id(&c->that.id, &d->that.id)
+           && !sameaddr(&c->that.host_addr, &d->that.host_addr))
 	    {
-		unorient_connection(d);
+		release_connection(d);
 	    }
 	    d = next;
 	}
-	
     }
 }
 
-/* Find a connection that owns the route to a connection's peer's client.
- * Preference is given to one that has an eroute too.
- * If eroute is true, our client must match too (as for eroutes).
+/* Find the connection to connection c's peer's client with the
+ * largest value of .routing.  All other things being equal,
+ * preference is given to c.  If none is routed, return NULL.
+ *
+ * If erop is non-null, set *erop to a connection sharing both
+ * our client subnet and peer's client subnet with the largest value
+ * of .routing.  If none is erouted, set *erop to NULL.
+ *
+ * The return value is used to find other connections sharing a route.
+ * *erop is used to find other connections sharing an eroute.
  */
 struct connection *
-route_owner(struct connection *c, bool eroute)
+route_owner(struct connection *c, struct connection **erop)
 {
-    struct connection
-	*d,
-	*best = NULL;
+    struct connection *d
+       , *bestro = c
+       , *bestero = c;
+    const ip_subnet *cc = EffectivePeerClient(c);
 
     passert(oriented(*c));
 
-    if (c->routed && c->eroute_owner != SOS_NOBODY)
-	return c;
-
-    for (d = connections; d != NULL; d = d->next)
+    for (d = connections; d != NULL; d = d->ac_next)
     {
-	if (d->routed)
+       if (d->routing != RT_UNROUTED   /* quick filter */
+       && samesubnet(cc, EffectivePeerClient(d)))
 	{
 	    passert(oriented(*d));
-	    if (samesubnet(&c->that.client, &d->that.client)
-	    && (!eroute || samesubnet(&c->this.client, &d->this.client)))
+           if (d->routing > bestro->routing)
+               bestro = d;
+           if (d->routing > bestero->routing
+           && samesubnet(&c->this.client, &d->this.client))
+               bestero = d;
+       }
+    }
+    DBG(DBG_CONTROL,
 	    {
-		if (d->eroute_owner != SOS_NOBODY)
-		    return d;	/* definite winner */
+           err_t m = builddiag("route owner of \"%s\" %s %s:"
+               , c->name
+               , enum_name(&connection_kind_names, c->kind)
+               , enum_name(&routing_story, c->routing));
 
-		best = d;	/* winner if no better comes along */
-	    }
+           if (!routed(bestro->routing))
+               m = builddiag("%s NULL", m);
+           else if (bestro == c)
+               m = builddiag("%s self", m);
+           else
+               m = builddiag("%s \"%s\" %s %s", m
+                   , bestro->name
+                   , enum_name(&connection_kind_names, bestro->kind)
+                   , enum_name(&routing_story, bestro->routing));
+
+           if (erop != NULL)
+	    {
+               m = builddiag("%s; eroute owner:", m);
+               if (!erouted(bestero->routing))
+                   m = builddiag("%s NULL", m);
+               else if (bestero == c)
+                   m = builddiag("%s self", m);
+               else
+                   m = builddiag("%s \"%s\" %s %s", m
+                       , bestero->name
+                       , enum_name(&connection_kind_names, bestero->kind)
+                       , enum_name(&routing_story, bestero->routing));
 	}
+
+           DBG_log("%s", m);
+       });
+    if (erop != NULL)
+       *erop = erouted(bestero->routing)? bestero : NULL;
+    return routed(bestro->routing)? bestro : NULL;
+}
+
+/* Find a connection that owns the shunt eroute between subnets.
+ * There ought to be only one.
+ * This might get to be a bottleneck -- try hashing if it does.
+ */
+struct connection *
+shunt_owner(const ip_subnet *ours, const ip_subnet *his)
+{
+    struct connection *c;
+
+    for (c = connections; c != NULL; c = c->ac_next)
+    {
+       if (shunt_erouted(c->routing)
+       && samesubnet(ours, &c->this.client)
+       && samesubnet(his, &c->that.client))
+           break;
     }
-    return best;
+    return c;
 }
 
+/* Find some connection with this pair of hosts.
+ * We don't know enough to chose amongst those available.
+ * ??? no longer usefully different from find_host_pair_connections
+ */
 struct connection *
 find_host_connection(const ip_address *me, u_int16_t my_port
 , const ip_address *him, u_int16_t his_port)
 {
-    struct connection *c = find_host_pair_connections(me, my_port, him, his_port);
-
-    if (c != NULL && !oriented(*c))
-	(void)orient(c, FALSE);
-    return c;
+    return find_host_pair_connections(me, my_port, him, his_port);
 }
 
-/* given an up-until-now satisfactory connection, find the best
- * connection now that we've got the Id Payload from the peer.
+/* given an up-until-now satisfactory connection, find the best connection
+ * now that we just got the Phase 1 Id Payload from the peer.
+ *
+ * Comments in the code describe the (tricky!) matching criteria.
+ * Although this routine could handle the initiator case,
+ * it isn't currently called in this case.
+ * This routine won't do anything interesting for Opportunistic Connections;
+ * it's not clear that anything useful could be done.
+ *
+ * In RFC 2409 "The Internet Key Exchange (IKE)",
+ * in 5.1 "IKE Phase 1 Authenticated With Signatures", describing Main
+ * Mode:
+ *
+ *         Initiator                          Responder
+ *        -----------                        -----------
+ *         HDR, SA                     -->
+ *                                     <--    HDR, SA
+ *         HDR, KE, Ni                 -->
+ *                                     <--    HDR, KE, Nr
+ *         HDR*, IDii, [ CERT, ] SIG_I -->
+ *                                     <--    HDR*, IDir, [ CERT, ] SIG_R
+ *
+ * In 5.4 "Phase 1 Authenticated With a Pre-Shared Key":
+ *
+ *               HDR, SA             -->
+ *                                   <--    HDR, SA
+ *               HDR, KE, Ni         -->
+ *                                   <--    HDR, KE, Nr
+ *               HDR*, IDii, HASH_I  -->
+ *                                   <--    HDR*, IDir, HASH_R
+ *
+ * refine_host_connection could be called in two case:
+ *
+ * - the Responder receives the IDii payload:
+ *   + [PSK] after using PSK to decode this message
+ *   + before sending its IDir payload
+ *   + before using its ID in HASH_R computation
+ *   + [DSig] before using its private key to sign SIG_R
+ *   + before using the Initiator's ID in HASH_I calculation
+ *   + [DSig] before using the Initiator's public key to check SIG_I
  *
- * We can only accept connections with compatible authentication.
- * The authentication method has been committed to.
- * The authentication materials are a slightly different matter.
- * We are committed to all authentication materials EXCEPT
- * in the case of RSA Sig authentication when we are the Responder.
- * In that case, the Initiator's public key is still open.
+ * - the Initiator receives the IDir payload:
+ *   + [PSK] after using PSK to encode previous message and decode this message
+ *   + after sending its IDii payload
+ *   + after using its ID in HASH_I computation
+ *   + [DSig] after using its private key to sign SIG_I
+ *   + before using the Responder's ID to compute HASH_R
+ *   + [DSig] before using Responder's public key to check SIG_R
+ *
+ * refine_host_connection can choose a different connection, as long as
+ * nothing already used is changed.
+ *
+ * In the Initiator case, the particular connection might have been
+ * specified by whatever provoked Pluto to initiate.  For example:
+ *	whack --initiate connection-name
+ * The advantages of switching connections when we're the Initiator seem
+ * less important than the disadvantages, so after FreeS/WAN 1.9, we
+ * don't do this.
  */
 struct connection *
 refine_host_connection(const struct state *st, const struct id *peer_id
@@ -1189,39 +1538,64 @@
     struct connection *d;
     lset_t auth_policy;
     const chunk_t *psk;
-    const struct RSA_public_key *his_RSA_pub;
-    const struct RSA_private_key *my_RSA_pri;
+    const struct RSA_private_key *my_RSA_pri = NULL;
     bool rw;
 
     if (same_id(&c->that.id, peer_id))
-	return c;
+	return c;       /* peer ID matches current connection -- look no further */
 
     switch (auth)
     {
     case OAKLEY_PRESHARED_KEY:
 	auth_policy = POLICY_PSK;
 	psk = get_preshared_secret(c);
+	/* It should be virtually impossible to fail to find PSK:
+	 * we just used it to decode the current message!
+	 */
 	if (psk == NULL)
 	    return NULL;	/* cannot determine PSK! */
 	break;
+
     case OAKLEY_RSA_SIG:
+#ifndef OPENSSL
 	auth_policy = POLICY_RSASIG;
+#else
+   case OAKLEY_RSA_ENC:
+   case OAKLEY_RSA_ENC_REV:
+	auth_policy = POLICY_OPENSSL;
+#endif
+	if (initiator)
+	{
+           /* at this point, we've committed to our RSA private key:
+            * we used it in our previous message.
+            */
 	my_RSA_pri = get_RSA_private_key(c);
 	if (my_RSA_pri == NULL)
 	    return NULL;	/* cannot determine my RSA private key! */
-	if (initiator)
-	{
-	    his_RSA_pub = get_his_RSA_public_key(c);
-	    if (his_RSA_pub == NULL)
-		return NULL;	/* cannot determine his RSA public key! */
 	}
 	break;
+#ifdef OPENSSL
+    case OAKLEY_DSS_SIG:
+    case OAKLEY_ELGAMAL_ENC:
+    case OAKLEY_ELGAMAL_ENC_REV:
+	auth_policy = POLICY_OPENSSL;
+	/* Not implemented yet */
+	break;
+#endif
     default:
 	passert(FALSE);
     }
+
     /* The current connection won't do: search for one that will.
      * First search for one with the same pair of hosts.
      * If that fails, search for one with a Road Warrior peer.
+     * We need to match:
+     * - peer_id (slightly complicated by instantiation)
+     * - if PSK auth, the key must not change (we used it to decode message)
+     * - policy-as-used must be acceptable to new connection
+     * - if initiator, also:
+     *   + our ID must not change (we sent it in previous message)
+     *   + our RSA key must not change (we used in in previous message)
      */
     d = c->host_pair->connections;
     for (rw = FALSE; ; rw = TRUE)
@@ -1230,22 +1604,40 @@
 
 	for (; d != NULL; d = d->hp_next)
 	{
-	    bool exact;
+	    bool exact = same_id(peer_id, &d->that.id); /* exact peer ID match? */
 
-	    if (!oriented(*d))
-		(void)orient(d, FALSE);
+#ifdef OPENSSL
+           /* fetch d's other cert, when applicable. */
+             if (auth_policy == POLICY_OPENSSL) {
+               bool r;
+               switch(auth) {
+                 case OAKLEY_RSA_SIG:
+                 case OAKLEY_RSA_ENC:
+                 case OAKLEY_RSA_ENC_REV:
+                   r = have_othercert(d, EVP_PKEY_RSA);
+                   break;
 
-	    if (!same_id(&c->this.id, &d->this.id))
+                  case OAKLEY_DSS_SIG:
+                 case OAKLEY_ELGAMAL_ENC:
+                 case OAKLEY_ELGAMAL_ENC_REV:
+                   r = have_othercert(d, EVP_PKEY_DSA);
+                   break;
+               default:
+                   passert(FALSE);
+               } /* END switch */
+             }
+#endif
+           /* check if peer_id matches, exactly or after instantiation */
+           if (!exact && !(rw && d->that.id.kind == ID_NONE))
 		continue;
 
-	    exact = same_id(peer_id, &d->that.id);
-
-	    if (exact || (rw && d->that.id.kind == ID_NONE))
-	    {
-		/* check whether authentication would work the same */
+           /* if initiator, our ID must match exactly */
+           if (initiator && !same_id(&c->this.id, &d->this.id))
+		continue;
 
-		if (!((d->policy & auth_policy) != 0
-		|| (d->policy & POLICY_ISAKMP_MASK) == 0))
+           /* authentication used must fit policy of this connection */
+           if (!((d->policy & auth_policy) != LEMPTY
+           || (d->policy & POLICY_ID_AUTH_MASK) == LEMPTY))
 		    continue;	/* our auth isn't OK for this connection */
 
 		switch (auth)
@@ -1263,25 +1655,27 @@
 				continue;	/* different secret */
 		    }
 		    break;
-		case OAKLEY_RSA_SIG:
-		    if (my_RSA_pri != get_RSA_private_key(d))
-			continue;	/* different private key */
 
-		    if (initiator)
-		    {
-			/* his public key has been used for authentication
-			 * so we must be sure that any connection we
-			 * select will use the same public key.
+           case OAKLEY_RSA_SIG:
+#ifdef OPENSSL
+           case OAKLEY_RSA_ENC:
+           case OAKLEY_RSA_ENC_REV:
+#endif
+               /* We must at least be able to find our private key.
+                * If we initiated, it must match the one we
+                * used in the SIG_I payload that we sent previously.
 			 */
-			const struct RSA_public_key *hnk = exact
-			    ? get_his_RSA_public_key(d) : get_RSA_public_key(peer_id);
-
-			passert(exact || d->gw_info == NULL);
+               {
+                   const struct RSA_private_key *pri
+                       = get_RSA_private_key(d);
 
-			if (!same_RSA_public_key(his_RSA_pub, hnk))
-			    continue;	/* different public key */
+                   if (pri == NULL
+                   || (initiator
+                       && !same_RSA_public_key(&my_RSA_pri->pub, &pri->pub)))
+                       continue;
 		    }
 		    break;
+
 		default:
 		    passert(FALSE);
 		}
@@ -1291,7 +1685,6 @@
 
 		best_found = d;	/* passed tests, but peer_id was wildcarded */
 	    }
-	}
 	if (rw)
 	    return best_found;	/* been around twice already */
 
@@ -1342,20 +1735,17 @@
 
     for (d = hp->connections; d != NULL; d = d->hp_next)
     {
-	if (!oriented(*d))
-	    (void)orient(d, FALSE);
-
 	if (!same_peer_ids(c, d, peer_id))
 	    continue;
 
 	if (oppo)
 	{
 	    /* Opportunistic case:
-	     * our_client must be inside the abstract client
-	     * and we must have a Wildcard Client.
+             * our_net must be inside d->this.client
+             * and d must have a Wildcard that.client.
 	     */
-	    if (!addrinsubnet(&d->this.host_addr, our_net)
-	    || !HasWildcardClient(c))
+            if (!subnetinsubnet(our_net, &d->this.client)
+            || !HasWildcardClient(d))
 		continue;
 	}
 	else
@@ -1387,7 +1777,7 @@
 	}
 
 	/* we've run the gauntlet -- success */
-	if (d->routed)
+	if (routed(d->routing))
 	    return d;
 
 	if (unrouted == NULL)
@@ -1412,7 +1802,7 @@
 	&& samesubnet(&c->that.client, peer_net))
 	{
 	    passert(oriented(*c));
-	    if (c->routed)
+	    if (routed(c->routing))
 		return c;
 
 	    unrouted = c;
@@ -1439,9 +1829,7 @@
 	    /* RW match with actual peer_id? */
 	    d = fc_try(FALSE, c, hp, NULL, our_net, peer_net);
 
-	    if (d == NULL
-	    && (c->that.id.kind == ID_IPV4_ADDR || c->that.id.kind == ID_IPV6_ADDR)
-	    && sameaddr(&c->that.id.ip_addr, &c->that.host_addr))
+	    if (d == NULL && his_id_was_instantiated(c))
 	    {
 		/* RW match with abstract peer_id?
 		 * Note that later instantiation will result in the same peer_id.
@@ -1470,11 +1858,10 @@
 {
     struct connection *c;
 
-    for (c = connections; c != NULL; c = c->next)
+    for (c = connections; c != NULL; c = c->ac_next)
     {
-	const char *routed = c->routed? "; routed" : "";
 	const char *ifn = oriented(*c)? c->interface->rname : "";
-	const char *instance = c->rw_state == rwcs_instance? " instance" : "";
+	const char *instance = c->kind == CK_INSTANCE? " instance" : "";
 
 	/* show topology */
 	{
@@ -1511,12 +1898,12 @@
 	    , (unsigned long) c->sa_keying_tries);
 
 	whack_log(RC_COMMENT
-	    , "\"%s\"%s:   policy: %s; interface: %s%s"
+	    , "\"%s\"%s:   policy: %s; interface: %s; %s"
 	    , c->name
 	    , instance
 	    , bitnamesof(sa_policy_bit_names, c->policy)
 	    , ifn
-	    , routed);
+            , enum_name(&routing_story, c->routing));
 
 	whack_log(RC_COMMENT
 	    , "\"%s\"%s:   newest ISAKMP SA: #%ld; newest IPsec SA: #%ld; eroute owner: #%lu"
@@ -1544,3 +1931,198 @@
     }
     return FALSE;
 }
+
+/* peer client, but for wildcard, subrange containing all */
+const ip_subnet *
+EffectivePeerClient(const struct connection *c)
+{
+    return c->kind == CK_TEMPLATE && HasWildcardClient(c)
+       ? aftoinfo(subnettypeof(&c->that.client))->all
+       : &c->that.client;
+}
+
+/* struct pending, the structure representing Quick Mode
+ * negotiations delayed until a Keying Channel has been negotiated.
+ * Essentially, a pending call to quick_outI1.
+ */
+
+struct pending {
+    int whack_sock;
+    struct state *isakmp_sa;
+    struct connection *connection;
+    lset_t policy;
+    unsigned long try;
+
+    struct pending *next;
+};
+
+/* queue a Quick Mode negotiation pending completion of a suitable Main Mode */
+void
+add_pending(int whack_sock
+, struct state *isakmp_sa
+, struct connection *c
+, lset_t policy
+, unsigned long try)
+{
+    struct pending *p = alloc_thing(struct pending, "struct pending");
+
+    DBG(DBG_CONTROL, DBG_log("Queuing pending Quick Mode with %s \"%s\""
+       , ip_str(&c->that.host_addr)
+       , c->name));
+    p->whack_sock = whack_sock;
+    p->isakmp_sa = isakmp_sa;
+    p->connection = c;
+    p->policy = policy;
+    p->try = try;
+    p->next = c->host_pair->pending;
+    c->host_pair->pending = p;
+}
+
+/* Release all the whacks awaiting the completion of this state.
+ * This is accomplished by closing all the whack socket file descriptors.
+ * We go to a lot of trouble to tell each whack, but to not tell it twice.
+ */
+void
+release_pending_whacks(struct state *st, err_t story)
+{
+    struct pending *p;
+    struct stat stst;
+
+    if (st->st_whack_sock == NULL_FD || fstat(st->st_whack_sock, &stst) != 0)
+       zero (&stst);   /* resulting st_dev/st_ino ought to be distinct */
+
+    release_whack(st);
+
+    for (p = st->st_connection->host_pair->pending; p != NULL; p = p->next)
+    {
+       if (p->isakmp_sa == st && p->whack_sock != NULL_FD)
+       {
+           struct stat pst;
+
+           if (fstat(p->whack_sock, &pst) == 0
+           && (stst.st_dev != pst.st_dev || stst.st_ino != pst.st_ino))
+           {
+               passert(whack_log_fd == NULL_FD);
+               whack_log_fd = p->whack_sock;
+               whack_log(RC_COMMENT
+                   , "%s for ISAKMP SA, but releasing whack for pending IPSEC SA"
+                   , story);
+               whack_log_fd = NULL_FD;
+           }
+           close(p->whack_sock);
+           p->whack_sock = NULL_FD;
+       }
+    }
+}
+
+static void
+delete_pending(struct pending **pp)
+{
+    struct pending *p = *pp;
+
+    *pp = p->next;
+    if (p->connection != NULL)
+       connection_discard(p->connection);
+    if (p->whack_sock != NULL_FD)
+       close(p->whack_sock);
+    pfree(p);
+}
+
+void
+unpend(struct state *st)
+{
+    struct pending **pp
+       , *p;
+
+    for (pp = &st->st_connection->host_pair->pending; (p = *pp) != NULL; )
+    {
+       if (p->isakmp_sa == st)
+       {
+           DBG(DBG_CONTROL, DBG_log("unqueuing pending Quick Mode with %s \"%s\""
+               , ip_str(&p->connection->that.host_addr)
+               , p->connection->name));
+           (void) quick_outI1(p->whack_sock, st, p->connection, p->policy
+               , p->try);
+           p->whack_sock = NULL_FD;    /* ownership transferred */
+           p->connection = NULL;       /* ownership transferred */
+           delete_pending(pp);
+       }
+       else
+       {
+           pp = &p->next;
+       }
+    }
+}
+
+/* a Main Mode negotiation has been replaced; update any pending */
+void
+update_pending(struct state *os, struct state *ns)
+{
+    struct pending *p;
+
+    for (p = os->st_connection->host_pair->pending; p != NULL; p = p->next)
+       if (p->isakmp_sa == os)
+           p->isakmp_sa = ns;
+}
+
+/* a Main Mode negotiation has failed; discard any pending */
+void
+flush_pending_by_state(struct state *st)
+{
+    struct pending **pp
+       , *p;
+
+    for (pp = &st->st_connection->host_pair->pending; (p = *pp) != NULL; )
+    {
+       if (p->isakmp_sa == st)
+           delete_pending(pp);
+       else
+           pp = &p->next;
+    }
+}
+
+/* a connection has been deleted; discard any related pending */
+static void
+flush_pending_by_connection(struct connection *c)
+{
+    if (c->host_pair != NULL)
+    {
+       struct pending **pp
+           , *p;
+
+       for (pp = &c->host_pair->pending; (p = *pp) != NULL; )
+       {
+           if (p->connection == c)
+           {
+               p->connection = NULL;   /* prevent delete_pending from releasing */
+               delete_pending(pp);
+           }
+           else
+           {
+               pp = &p->next;
+           }
+       }
+    }
+}
+
+/* Delete a connection if it is an instance and it is no longer in use.
+ * We must be careful to avoid circularity:
+ * we don't touch it if it is CK_GOING_AWAY.
+ */
+void
+connection_discard(struct connection *c)
+{
+    if (c->kind == CK_INSTANCE)
+    {
+       /* see if it is being used by a pending */
+       struct pending *p;
+
+       for (p = c->host_pair->pending; p != NULL; p = p->next)
+           if (p->connection == c)
+               return; /* in use, so we're done */
+
+       if (!states_use_connection(c))
+           delete_connection(c);
+    }
+}
+
